明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1712|回复: 3

检查了好多遍都没有问题,可运行就是不行!

[复制链接]
发表于 2004-4-27 20:10:00 | 显示全部楼层 |阅读模式
程序的目的是将3D多段线的所有节点的Z坐标去掉,然后生成一2D多段线。思路应该没有问题,可老提示坐标越界。哪位帮我看看到底是怎么回事。   用下面这个图形做测试。
  1. Sub test3Dto2D()
  2. '创建选择集
  3. Dim selset As AcadSelectionSet
  4. Dim cor3 As Variant
  5. Dim n As Integer
  6. Dim a As Integer
  7. a = 0
  8. Set selset = ThisDrawing.SelectionSets.Add("sset")
  9. selset.Select acSelectionSetAll         '遍历选择集并将每一个对象镜相
  10. Dim entry As AcadObject
  11. Dim pl As AcadLWPolylineFor Each entry In selset
  12.      If entry.EntityName = "AcDb3dPolyline" Then
  13.                cor3 = entry.Coordinates
  14.                n = (UBound(cor3) + 1) * 2 / 3
  15.                Dim pt() As Double
  16.                ReDim pt(0 To n - 1) As Double                       For i = 0 To (n - 2) Step 2
  17.                                pt(i) = cor3(a)
  18.                                pt(i + 1) = cor3(a + 1)
  19.                                a = a + 3
  20.                        Next i
  21.                        
  22.                Set pl = ThisDrawing.ModelSpace.AddLightWeightPolyline(pt)
  23.                entry.Delete
  24.        End If
  25. Next entryselset.Delete '避免下次重复End Sub

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有账号?注册

x
发表于 2004-4-27 20:33:00 | 显示全部楼层
在 entry.Delete后面加上 a=0
 楼主| 发表于 2004-4-27 20:36:00 | 显示全部楼层
嘿嘿!多谢,我太粗心了!
发表于 2004-4-27 20:42:00 | 显示全部楼层
本帖最后由 作者 于 2004-4-28 10:00:25 编辑
  1. Sub tn = (UBound(cor3) + 1) * 2 / 3
  2.                Dim pt() As Double
  3.                ReDim pt(0 To n - 1) As Double
  4.                        For i = 0 To (n - 2) Step 2
这里太乱了,改为sub test3Dto2D()
'创建选择集
Dim selset As AcadSelectionSet
Dim cor3 As Variant
Dim n As Integer
Set selset = ThisDrawing.SelectionSets.Add("sset")
selset.Select acSelectionSetAll         '遍历选择集并将每一个对象镜相
Dim entry As AcadObject
Dim pl As AcadLWPolylineFor Each entry In selset
     If entry.EntityName = "AcDb3dPolyline" Then
               cor3 = entry.Coordinates
               n = (UBound(cor3) + 1) / 3
               Dim pt() As Double
               ReDim pt(0 To n * 2 - 1) As Double                       For i = 0 To n - 1
                               pt(i * 2) = cor3(i * 3)
                               pt(i * 2 + 1) = cor3(i * 3 + 1)
                       Next i
                       
               Set pl = ThisDrawing.ModelSpace.AddLightWeightPolyline(pt)
               entry.Delete
       End If
Next entryselset.Delete '避免下次重复End Sub
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-28 06:33 , Processed in 0.167093 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表